diff --git a/src/test/test.c b/src/test/test.c
new file mode 100644
index 0000000..ebe012e
--- /dev/null
+++ b/src/test/test.c
@@ -0,0 +1,484 @@
+// test.cpp : Defines the entry point for the console application.
+//
+
+#include <stdio.h>
+#include <string.h>
+#include <fcntl.h>
+
+#include <stdlib.h>
+#include <trousers/tss.h>
+#include <trousers/trousers.h>
+
+#ifdef WIN32
+#include <windows.h>
+#include <sys/stat.h>
+#else
+#include <sys/stat.h>
+#endif
+
+#define ERR 1
+
+#ifdef RAND
+int main (int argc, char ** argv) {
+
+    TSS_HCONTEXT        hContext;
+    TSS_RESULT          result;
+    TSS_HTPM            hTPM;
+    BYTE                *rand;
+	int i, j;
+    
+    TSS_UUID SRK_UUID = TSS_UUID_SRK;
+
+    result = Tspi_Context_Create( &hContext );
+    if ( result != TSS_SUCCESS )
+    {
+        printf( "ERR - Tspi_Context_Create");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+    }
+
+    result = Tspi_Context_Connect( hContext, NULL );
+    if ( result != TSS_SUCCESS )
+    {
+        printf( "ERR - Tspi_Context_Connect");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+    }
+    
+    result = Tspi_Context_GetTpmObject( hContext, &hTPM );
+    if ( result != TSS_SUCCESS )
+    {
+        printf( "ERR - Tspi_Context_GetTpmObject");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+    }
+
+    for( i=0; i<2; i++ )
+    {
+        for( j=0; j<6; j++ )
+        {
+            result = Tspi_TPM_GetRandom( hTPM, 1, &rand );
+            if ( result != TSS_SUCCESS )
+            {
+                printf( "ERR - Tspi_Context_GetTpmObject");
+                Tspi_Context_FreeMemory( hContext, NULL );
+                Tspi_Context_Close( hContext );
+                exit (ERR);
+            }
+            printf("%d ", (*rand%90)+1 );
+        }
+        printf("\n");    
+    }
+        
+    /* Clean */
+	Tspi_Context_CloseObject( hContext, hTPM );
+    Tspi_Context_FreeMemory( hContext, NULL );
+    Tspi_Context_Close( hContext );
+
+    return 0;
+}
+#endif
+
+
+#ifdef CREATEKEY
+int main(int argc, char **argv)
+{
+	TSS_HCONTEXT hContext;
+	TSS_HPOLICY  hPolicySRK ;
+	TSS_HKEY     hSrk;
+	TSS_HKEY     hKey;	
+	TSS_RESULT   result;
+	char srkpwd[50];
+	int srkpwdlen= 0;
+	TSS_UUID SRK_UUID=TSS_UUID_SRK;
+	BYTE *keyblob = NULL;
+	UINT32 keylen = 0;
+	int fp;
+	TSS_FLAG keyFlags = TSS_KEY_TYPE_STORAGE | TSS_KEY_SIZE_2048
+			| TSS_KEY_VOLATILE | TSS_KEY_AUTHORIZATION | TSS_KEY_NOT_MIGRATABLE;
+	
+	result = Tspi_Context_Create(&hContext);
+	if (result != TSS_SUCCESS) {
+		printf("Error: Tspi_Context_Create returned %d\n", result);
+		exit(result);
+	}
+	
+	result = Tspi_Context_Connect(hContext,NULL);
+	if (result != TSS_SUCCESS) {
+		printf("Error: Tspi_Context_Connect returned %d)\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);                 
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}	
+	
+	if((result = Tspi_Context_LoadKeyByUUID(hContext, TSS_PS_TYPE_SYSTEM, SRK_UUID, &hSrk)) != 0) {
+		printf("LoadKeyByUUID(): res: %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+	
+	result = Tspi_GetPolicyObject(hSrk, TSS_POLICY_USAGE, &hPolicySRK);
+	if (result != TSS_SUCCESS)
+	{
+		printf("Error: Tspi_GetPolicyObject returned %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+		
+	/* Set password */	
+	printf("Insert the TPM SRK password: ");
+	scanf("%s", srkpwd);
+	srkpwdlen = strlen(srkpwd);
+
+	result = Tspi_Policy_SetSecret(hPolicySRK, TSS_SECRET_MODE_PLAIN, srkpwdlen, (BYTE *)srkpwd);
+	if (result != TSS_SUCCESS)
+	{
+		printf("Error: Tspi_Policy_SetSecret returned %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+	
+	result = Tspi_Context_CreateObject(hContext,TSS_OBJECT_TYPE_RSAKEY, keyFlags, &hKey); 
+	if (result != 0)
+	{
+		printf("Error: Tspi_GetPolicyObject returned %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+	
+/*	if((result = Tspi_SetAttribUint32(hKey, TSS_TSPATTRIB_KEY_INFO, TSS_TSPATTRIB_KEYINFO_USAGE, TSS_KEYUSAGE_BIND))!= 0) {
+		printf("Tspi_SetAttribUint32(): res: %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}*/
+	
+	if((result = Tspi_Key_CreateKey(hKey, hSrk, 0))!= 0) {
+		printf("CreateKey(): res: %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}	
+	
+	printf("Result: %d\n", result);
+	Tspi_GetAttribData(hKey, TSS_TSPATTRIB_KEY_BLOB, TSS_TSPATTRIB_KEYBLOB_BLOB, &keylen, &keyblob);
+#ifdef WIN32
+	if((fp=open("key", O_WRONLY | O_CREAT | O_BINARY, 0600))<0)
+#else
+	if((fp=open("key", O_WRONLY | O_CREAT, 0600))<0)
+#endif
+		goto end_create;
+
+	write(fp, (char *)keyblob, keylen);
+	close(fp);
+
+end_create:
+	Tspi_Key_UnloadKey(hKey);
+	Tspi_Key_UnloadKey(hSrk);
+	Tspi_Context_CloseObject(hContext,hKey);
+	Tspi_Context_CloseObject(hContext,hSrk);
+	Tspi_Context_CloseObject(hContext,hPolicySRK);
+	Tspi_Context_Close(hContext);
+	
+	return result;
+}
+
+#endif
+
+#ifdef LOADKEY
+
+int createkey2(TSS_HCONTEXT hContext, TSS_HKEY hParent)
+{
+	TSS_RESULT   result;
+	char srkpwd[50];
+	int srkpwdlen= 0;
+	TSS_UUID SRK_UUID=TSS_UUID_SRK;
+	BYTE *keyblob = NULL;
+	UINT32 keylen = 0;
+	int fp;
+	TSS_HKEY hKey;
+	
+	TSS_FLAG keyFlags = TSS_KEY_TYPE_BIND | TSS_KEY_SIZE_2048  | \
+									 TSS_KEY_VOLATILE | TSS_KEY_AUTHORIZATION  | \
+									 TSS_KEY_NOT_MIGRATABLE;
+
+	
+		
+	/* Set password */	
+/*	printf("Insert the TPM SRK password: ");
+	scanf("%s", srkpwd);
+	srkpwdlen = strlen(srkpwd);
+
+	result = Tspi_Policy_SetSecret(hPolicySRK, TSS_SECRET_MODE_PLAIN, srkpwdlen, (BYTE *)srkpwd);
+	if (result != TSS_SUCCESS)
+	{
+		printf("Error: Tspi_Policy_SetSecret returned %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+*/	
+	result = Tspi_Context_CreateObject(hContext,TSS_OBJECT_TYPE_RSAKEY, keyFlags, &hKey); 
+	if (result != 0)
+	{
+		printf("Error: Tspi_GetPolicyObject returned %d(%s)\n", result, Trspi_Error_String(result));
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+	
+/*	if((result = Tspi_SetAttribUint32(hKey, TSS_TSPATTRIB_KEY_INFO, TSS_TSPATTRIB_KEYINFO_USAGE, TSS_KEYUSAGE_BIND))!= 0) {
+		printf("Tspi_SetAttribUint32(): res: %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}*/
+	
+	if((result = Tspi_Key_CreateKey(hKey, hParent, 0))!= 0) {
+		printf("CreateKey(): res: %d(%s)\n", result, Trspi_Error_String(result));
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}	
+	
+	printf("Result: %d(%s)\n", result, Trspi_Error_String(result));
+	Tspi_GetAttribData(hKey, TSS_TSPATTRIB_KEY_BLOB, TSS_TSPATTRIB_KEYBLOB_BLOB, &keylen, &keyblob);
+#ifdef WIN32
+	if((fp=open("key2", O_WRONLY | O_CREAT | O_BINARY, 0600))<0)
+#else
+	if((fp=open("key2", O_WRONLY | O_CREAT, 0600))<0)
+#endif
+		goto end_create;
+
+	write(fp, (char *)keyblob, keylen);
+	close(fp);
+
+end_create:
+	Tspi_Key_UnloadKey(hKey);
+	Tspi_Context_CloseObject(hContext,hKey);
+
+	return result;
+}
+
+int main(int argc, char **argv)
+{
+	TSS_HCONTEXT hContext;
+	TSS_HPOLICY  hPolicySRK ;
+	TSS_HKEY     hSrk;
+	TSS_HKEY     hKey;	
+	TSS_RESULT   result;
+	char srkpwd[50];
+	int srkpwdlen= 0;
+	TSS_UUID SRK_UUID=TSS_UUID_SRK;
+	BYTE *keyblob = NULL;
+	UINT32 keylen = 0;
+	int fp;
+	struct stat st;
+	
+	result = Tspi_Context_Create(&hContext);
+	if (result != TSS_SUCCESS) {
+		printf("Error: Tspi_Context_Create returned %d(%s)\n", result, Trspi_Error_String(result));
+		exit(result);
+	}
+	
+	result = Tspi_Context_Connect(hContext,NULL);
+	if (result != TSS_SUCCESS) {
+		printf("Error: Tspi_Context_Connect returned %d(%s)\n", result, Trspi_Error_String(result));
+		Tspi_Context_FreeMemory(hContext, NULL);                 
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}	
+	
+	if((result = Tspi_Context_LoadKeyByUUID(hContext, TSS_PS_TYPE_SYSTEM, SRK_UUID, &hSrk)) != 0) {
+		printf("LoadKeyByUUID(): res: %d\n", result);
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+	
+	result = Tspi_GetPolicyObject(hSrk, TSS_POLICY_USAGE, &hPolicySRK);
+	if (result != TSS_SUCCESS)
+	{
+		printf("Error: Tspi_GetPolicyObject returned %d(%s)\n", result, Trspi_Error_String(result));
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+		
+	/* Set password */	
+	printf("Insert the TPM SRK password: ");
+	scanf("%s", srkpwd);
+	srkpwdlen = strlen(srkpwd);
+
+	result = Tspi_Policy_SetSecret(hPolicySRK, TSS_SECRET_MODE_PLAIN, srkpwdlen, (BYTE *)srkpwd);
+	if (result != TSS_SUCCESS)
+	{
+		printf("Error: Tspi_Policy_SetSecret returned %d(%s)\n", result, Trspi_Error_String(result));
+		Tspi_Context_FreeMemory(hContext, NULL);
+		Tspi_Context_Close(hContext);
+		exit(result);
+	}
+
+	stat("key", &st);
+	keylen = st.st_size;
+	keyblob=calloc(keylen, sizeof(BYTE));
+#ifdef WIN32	
+	if((fp=open("key", O_RDONLY | O_BINARY))<0)
+#else
+	if((fp=open("key", O_RDONLY))<0)
+#endif
+		goto end_load;
+
+	read(fp, (char *)keyblob, keylen);
+	close(fp);
+
+	if((result=Tspi_Context_LoadKeyByBlob(hContext, hSrk, keylen, keyblob, &hKey))!= 0) {
+		printf("LoadKeyByBlob(): res: %d(%s)\n", result), Trspi_Error_String(result);
+		goto end_load;
+	}
+
+	printf("Result: %d(%s)\n", result, Trspi_Error_String(result));
+
+	createkey2(hContext, hKey);
+
+end_load:
+	Tspi_Key_UnloadKey(hKey);
+	Tspi_Key_UnloadKey(hSrk);
+	Tspi_Context_CloseObject(hContext,hKey);
+	Tspi_Context_CloseObject(hContext,hSrk);
+	Tspi_Context_CloseObject(hContext,hPolicySRK);
+	Tspi_Context_Close(hContext);
+	
+	return result;
+
+
+
+}
+#endif
+
+#ifdef TAKE_OWNERSHIP
+int main (int argc, char ** argv) {
+
+    TSS_HCONTEXT        hContext;
+    TSS_RESULT          result;
+    TSS_HTPM            hTPM;
+	TSS_HPOLICY			hPolicy;	
+	TSS_HPOLICY			hPolicy1;
+	char				secret_owner[50] = {0};
+	char				secret_srk[50] = {0};
+	int					secret_owner_len = 0;
+	int					secret_srk_len = 0;
+	TSS_FLAG			keyFlags = TSS_KEY_TSP_SRK | TSS_KEY_AUTHORIZATION;
+    TSS_HKEY			hSRK;
+
+    TSS_UUID SRK_UUID = TSS_UUID_SRK;
+
+	/* Be careful with scanf!! Buffer Overflow!!! :-) */
+	printf("Insert the TPM Owner password: ");
+	scanf("%s", secret_owner);
+	secret_owner_len = strlen(secret_owner);
+
+	printf("Insert the TPM SRK password: ");
+	scanf("%s", secret_srk);
+	secret_srk_len = strlen(secret_srk);
+
+    result = Tspi_Context_Create( &hContext );
+    if ( result != TSS_SUCCESS )
+    {
+        printf( "ERR - Tspi_Context_Create");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+    }
+
+    result = Tspi_Context_Connect( hContext, NULL );
+    if ( result != TSS_SUCCESS )
+    {
+        printf( "ERR - Tspi_Context_Connect");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+    }
+    
+    result = Tspi_Context_GetTpmObject( hContext, &hTPM );
+    if ( result != TSS_SUCCESS )
+    {
+        printf( "ERR - Tspi_Context_GetTpmObject");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+    }
+
+	result = Tspi_GetPolicyObject(hTPM, TSS_POLICY_USAGE, &hPolicy);
+	if (result != TSS_SUCCESS) {
+        printf( "ERR - Tspi_GetPolicyObject");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+	}
+
+	result = Tspi_Policy_SetSecret(hPolicy, TSS_SECRET_MODE_PLAIN,
+			secret_owner_len, (BYTE*)secret_owner);
+	if (result != TSS_SUCCESS) {
+        printf( "ERR - Tspi_Policy_SetSecret");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+	}
+
+	result = Tspi_Context_CreateObject(hContext,
+			TSS_OBJECT_TYPE_RSAKEY, keyFlags, &hSRK);
+	if (result != TSS_SUCCESS) {
+		printf( "ERR - Tspi_Context_CreateObject");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+	}
+
+	result = Tspi_Context_CreateObject(hContext,
+			TSS_OBJECT_TYPE_POLICY, TSS_POLICY_USAGE, &hPolicy1);
+	if (result != TSS_SUCCESS) {
+		printf( "ERR - Tspi_Context_CreateObject");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+	}
+
+	result = Tspi_Policy_SetSecret(hPolicy1, TSS_SECRET_MODE_PLAIN,
+		secret_srk_len, (BYTE *)secret_srk);
+	if (result != TSS_SUCCESS) {
+		printf( "ERR - Tspi_Policy_SetSecret");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+	}
+
+	result = Tspi_Policy_AssignToObject(hPolicy1, hSRK);
+	if (result != TSS_SUCCESS) {
+		printf( "ERR - Tspi_Policy_AssignToObject");
+        Tspi_Context_FreeMemory( hContext, NULL );
+        Tspi_Context_Close( hContext );
+        exit (ERR);
+	}
+
+	result = Tspi_TPM_TakeOwnership(hTPM, hSRK, (TSS_HKEY)NULL);
+	if (result != TSS_SUCCESS) {
+		printf( "ERR - Tspi_TPM_TakeOwnership or Ownership already taken");
+        goto end;
+	}
+
+end:
+	Tspi_Context_CloseObject(hContext,hTPM);
+	Tspi_Context_CloseObject(hContext,hSRK);
+	Tspi_Context_CloseObject(hContext,hPolicy);
+	Tspi_Context_CloseObject(hContext,hPolicy1);
+	Tspi_Context_Close(hContext);
+}
+#endif
diff --git a/src/trspi/Makefile.am b/src/trspi/Makefile.am
index 300e492..dac2ed8 100644
--- a/src/trspi/Makefile.am
+++ b/src/trspi/Makefile.am
@@ -1,7 +1,7 @@
 noinst_LTLIBRARIES=libtrousers.la
 
 libtrousers_la_SOURCES=trousers.c crypto/@CRYPTO_PACKAGE@/hash.c
-libtrousers_la_CFLAGS=-DAPPID=\"TSPI\" -I${top_srcdir}/src/include
+libtrousers_la_CFLAGS=-DAPPID=\"TSPI\" -I${top_srcdir}/src/include -DTRSPDLL_EXPORTS
 
 if TSS_BUILD_ASYM_CRYPTO
 libtrousers_la_SOURCES+=crypto/@CRYPTO_PACKAGE@/rsa.c
diff --git a/src/trspi/trousers.c b/src/trspi/trousers.c
index e4007a8..d53ee91 100644
--- a/src/trspi/trousers.c
+++ b/src/trspi/trousers.c
@@ -9,13 +9,24 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#include "libc_interface.h"
+#define inline __inline
+#define BSD_CONST
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/mman.h>
 #include <langinfo.h>
+#endif
 #include <iconv.h>
 #include <wchar.h>
 #include <errno.h>
@@ -1231,7 +1242,7 @@ Trspi_LoadBlob_BOUND_DATA(UINT64 *offset, TCPA_BOUND_DATA bd, UINT32 payloadLeng
 }
 
 /* function to mimic strerror with TSS error codes */
-char *
+TRSPICALL char *
 Trspi_Error_String(TSS_RESULT r)
 {
 	/* Check the return code to see if it is common to all layers.
@@ -1450,7 +1461,7 @@ Trspi_Error_String(TSS_RESULT r)
 	}
 }
 
-char *
+TRSPICALL char *
 Trspi_Error_Layer(TSS_RESULT r)
 {
 	switch (TSS_ERROR_LAYER(r)) {
@@ -1462,7 +1473,7 @@ Trspi_Error_Layer(TSS_RESULT r)
 	}
 }
 
-TSS_RESULT
+TRSPICALL TSS_RESULT
 Trspi_Error_Code(TSS_RESULT r)
 {
 	return TSS_ERROR_CODE(r);
@@ -1508,6 +1519,7 @@ char_width(char *codeset)
 }
 
 #define MAX_BUF_SIZE	4096
+#define CODESET_LENGTH 	13
 
 BYTE *
 Trspi_Native_To_UNICODE(BYTE *string, unsigned *size)
@@ -1517,16 +1529,31 @@ Trspi_Native_To_UNICODE(BYTE *string, unsigned *size)
 	unsigned len = 0, tmplen;
 	iconv_t cd = 0;
 	size_t rc, outbytesleft, inbytesleft;
+#ifdef WIN32
+	static char buf[CODESET_LENGTH];
+	char *codeset;
+
+	snprintf (buf, CODESET_LENGTH, "CP%u", GetACP ());
+	codeset = buf;
+#endif
 
 	if (string == NULL)
 		goto alloc_string;
 
+#ifdef WIN32
+	if ((cd = iconv_open("UTF-16LE", codeset)) == (iconv_t)-1) {
+#else
 	if ((cd = iconv_open("UTF-16LE", nl_langinfo(CODESET))) == (iconv_t)-1) {
+#endif
 		LogDebug("iconv_open: %s", strerror(errno));
 		return NULL;
 	}
 
+#ifdef WIN32
+	if ((tmplen = hacky_strlen(codeset, string)) == 0) {
+#else
 	if ((tmplen = hacky_strlen(nl_langinfo(CODESET), string)) == 0) {
+#endif
 		LogDebug("hacky_strlen returned 0");
 		goto alloc_string;
 	}
@@ -1576,14 +1603,24 @@ Trspi_UNICODE_To_Native(BYTE *string, unsigned *size)
 	unsigned len = 0, tmplen;
 	iconv_t cd;
 	size_t rc, outbytesleft, inbytesleft;
+#ifdef WIN32
+	static char buf[CODESET_LENGTH];
+	char *codeset;
+
+	snprintf (buf, CODESET_LENGTH, "CP%u", GetACP());
+	codeset = buf;
+#endif
 
 	if (string == NULL) {
 		if (size)
 			*size = 0;
 		return NULL;
 	}
-
+#ifdef WIN32
+	if ((cd = iconv_open(codeset, "UTF-16LE")) == (iconv_t)-1) {
+#else
 	if ((cd = iconv_open(nl_langinfo(CODESET), "UTF-16LE")) == (iconv_t)-1) {
+#endif
 		LogDebug("iconv_open: %s", strerror(errno));
 		return NULL;
 	}
@@ -1605,7 +1642,11 @@ Trspi_UNICODE_To_Native(BYTE *string, unsigned *size)
 	} while (rc == (size_t)-1 && errno == E2BIG);
 
 	/* add terminating bytes of the correct width */
+#ifdef WIN32
+	len += char_width(codeset);
+#else
 	len += char_width(nl_langinfo(CODESET));
+#endif
 	if (len > MAX_BUF_SIZE) {
 		LogDebug("string too long.");
 		iconv_close(cd);
diff --git a/src/tspi/Makefile.am b/src/tspi/Makefile.am
index 89fc011..94fce22 100644
--- a/src/tspi/Makefile.am
+++ b/src/tspi/Makefile.am
@@ -1,7 +1,13 @@
 lib_LTLIBRARIES=libtspi.la
 
+#noinst_DATA = libtspi.dll libtspi.dll.a libtspi.def
+
 libtspi_la_LIBADD=${top_builddir}/src/trspi/libtrousers.la
 
+if OS_WIN32
+libtspi_la_LIBADD+=${top_builddir}/src/win32/libc_interface.la
+endif
+
 # On setting -version-info, from the libtool manual:
 #
 # -version-info current:revision:age
@@ -17,9 +23,13 @@ libtspi_la_LIBADD=${top_builddir}/src/trspi/libtrousers.la
 # 5. If any interfaces have been added since the last public release, then increment age.
 # 6. If any interfaces have been removed since the last public release, then set age to 0.
 
-libtspi_la_LDFLAGS=-version-info 2:3:1 -lpthread @CRYPTOLIB@
+libtspi_la_LDFLAGS=-version-info 2:3:1 -lpthread @CRYPTOLIB@ @EXTRATSPLIB@
+
+if OS_WIN32
+libtspi_la_LDFLAGS+=-no-undefined 
+endif
 
-libtspi_la_CFLAGS=-I$(top_srcdir)/src/include -DAPPID=\"TSPI\" -DVAR_PREFIX=\"@localstatedir@\" -DETC_PREFIX=\"@sysconfdir@\"
+libtspi_la_CFLAGS=-I$(top_srcdir)/src/include -DAPPID=\"TSPI\" -DVAR_PREFIX=\"@localstatedir@\" -DETC_PREFIX=\"@sysconfdir@\" -DTSPDLL_EXPORTS -DTRSP_STATIC
 
 libtspi_la_SOURCES=log.c \
                    spi_utils.c \
diff --git a/src/tspi/gtk/interface.c b/src/tspi/gtk/interface.c
index c295beb..ce54bbf 100644
--- a/src/tspi/gtk/interface.c
+++ b/src/tspi/gtk/interface.c
@@ -18,7 +18,9 @@
 
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <string.h>
 #include <stdio.h>
 
diff --git a/src/tspi/gtk/support.c b/src/tspi/gtk/support.c
index 6ce3870..b03389f 100644
--- a/src/tspi/gtk/support.c
+++ b/src/tspi/gtk/support.c
@@ -18,7 +18,9 @@
 
 #include <sys/types.h>
 #include <sys/stat.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <string.h>
 #include <stdio.h>
 
diff --git a/src/tspi/obj_context.c b/src/tspi/obj_context.c
index cb2091e..2c0f49d 100644
--- a/src/tspi/obj_context.c
+++ b/src/tspi/obj_context.c
@@ -910,7 +910,7 @@ do_transport_decryption(TPM_TRANSPORT_PUBLIC *transPub,
 	UINT32 i, decLen;
 	UINT32 seedLen, ivLen;
 	BYTE *dec;
-	BYTE seed[(2 * sizeof(TPM_NONCE)) + strlen("out") + TPM_SHA1_160_HASH_LEN];
+	BYTE *seed;
 
 	/* allocate the most data anyone below might need */
 	decLen = inLen;//((inLen / TSS_MAX_SYM_BLOCK_SIZE) + 1) * TSS_MAX_SYM_BLOCK_SIZE;
@@ -919,6 +919,13 @@ do_transport_decryption(TPM_TRANSPORT_PUBLIC *transPub,
 		return TSPERR(TSS_E_OUTOFMEMORY);
 	}
 
+	seedLen = (2 * sizeof(TPM_NONCE)) + strlen("out") + TPM_SHA1_160_HASH_LEN;
+	if ((seed = malloc(seedLen + 1)) == NULL) {
+		LogError("malloc of %u bytes failed", seedLen);
+		free(dec);
+		return TSPERR(TSS_E_OUTOFMEMORY);
+	}
+
 	/* set the common 3 initial values of 'seed', which is used to generate either the IV or
 	 * mask */
 	memcpy(seed, pTransAuth->NonceEven.nonce, sizeof(TPM_NONCE));
@@ -934,10 +941,8 @@ do_transport_decryption(TPM_TRANSPORT_PUBLIC *transPub,
 		/* add the secret data to the seed for MGF1 */
 		memcpy(&seed[2 * sizeof(TPM_NONCE) + strlen("out")], secret, TPM_SHA1_160_HASH_LEN);
 
-		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, decLen, dec))) {
-			free(dec);
-			return result;
-		}
+		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, decLen, dec)))
+			goto fail;
 
 		for (i = 0; i < inLen; i++)
 			dec[i] ^= in[i];
@@ -950,17 +955,13 @@ do_transport_decryption(TPM_TRANSPORT_PUBLIC *transPub,
 		ivLen = TSS_MAX_SYM_BLOCK_SIZE;
 		seedLen = (2 * sizeof(TPM_NONCE)) + strlen("out");
 
-		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, ivLen, iv))) {
-			free(dec);
-			return result;
-		}
+		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, ivLen, iv)))
+			goto fail;
 
 		/* use the secret data as the key for AES */
 		if ((result = Trspi_SymEncrypt(transPub->algId, transPub->encScheme, secret, iv, in,
-					       inLen, dec, &decLen))) {
-			free(dec);
-			return result;
-		}
+					       inLen, dec, &decLen)))
+			goto fail;
 
 		break;
 	}
@@ -973,6 +974,11 @@ do_transport_decryption(TPM_TRANSPORT_PUBLIC *transPub,
 
 	*out = dec;
 	*outLen = decLen;
+	return TSS_SUCCESS;
+
+fail:
+	free(dec);
+	free(seed);
 
 	return result;
 }
@@ -989,8 +995,8 @@ do_transport_encryption(TPM_TRANSPORT_PUBLIC *transPub,
 	TSS_RESULT result;
 	UINT32 i, encLen;
 	UINT32 seedLen, ivLen;
-	BYTE *enc;
-	BYTE seed[(2 * sizeof(TPM_NONCE)) + strlen("in") + TPM_SHA1_160_HASH_LEN];
+	BYTE *enc = NULL;
+	BYTE *seed = NULL;
 
 	/* allocate the most data anyone below might need */
 	encLen = ((inLen / TSS_MAX_SYM_BLOCK_SIZE) + 1) * TSS_MAX_SYM_BLOCK_SIZE;
@@ -999,6 +1005,13 @@ do_transport_encryption(TPM_TRANSPORT_PUBLIC *transPub,
 		return TSPERR(TSS_E_OUTOFMEMORY);
 	}
 
+	seedLen = (2 * sizeof(TPM_NONCE)) + strlen("in") + TPM_SHA1_160_HASH_LEN;
+	if ((seed = malloc(seedLen + 1)) == NULL) {
+		LogError("malloc of %u bytes failed", seedLen);
+		free(enc);
+		return TSPERR(TSS_E_OUTOFMEMORY);
+	}
+
 	/* set the common 3 initial values of 'seed', which is used to generate either the IV or
 	 * mask */
 	memcpy(seed, pTransAuth->NonceEven.nonce, sizeof(TPM_NONCE));
@@ -1014,10 +1027,8 @@ do_transport_encryption(TPM_TRANSPORT_PUBLIC *transPub,
 		/* add the secret data to the seed for MGF1 */
 		memcpy(&seed[2 * sizeof(TPM_NONCE) + strlen("in")], secret, TPM_SHA1_160_HASH_LEN);
 
-		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, encLen, enc))) {
-			free(enc);
-			return result;
-		}
+		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, encLen, enc)))
+			goto fail;
 
 		for (i = 0; i < inLen; i++)
 			enc[i] ^= in[i];
@@ -1030,30 +1041,31 @@ do_transport_encryption(TPM_TRANSPORT_PUBLIC *transPub,
 		ivLen = TSS_MAX_SYM_BLOCK_SIZE;
 		seedLen = (2 * sizeof(TPM_NONCE)) + strlen("in");
 
-		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, ivLen, iv))) {
-			free(enc);
-			return result;
-		}
+		if ((result = Trspi_MGF1(TSS_HASH_SHA1, seedLen, seed, ivLen, iv)))
+			goto fail;
 
 		/* use the secret data as the key for AES */
 		if ((result = Trspi_SymEncrypt(transPub->algId, transPub->encScheme, secret, iv, in,
-					       inLen, enc, &encLen))) {
-			free(enc);
-			return result;
-		}
+					       inLen, enc, &encLen)))
+			goto fail;
 
 		break;
 	}
 	default:
 		LogDebug("Unknown algorithm for encrypted transport session: 0x%x",
 			 transPub->algId);
-		free(enc);
-		return TSPERR(TSS_E_INTERNAL_ERROR);
+		result = TSPERR(TSS_E_INTERNAL_ERROR);
+		goto fail;
 	}
 
 	*out = enc;
 	*outLen = encLen;
 
+	return TSS_SUCCESS;
+fail:
+	free(enc);
+	free(seed);
+
 	return result;
 }
 
diff --git a/src/tspi/obj_policy.c b/src/tspi/obj_policy.c
index f19a02f..e76681b 100644
--- a/src/tspi/obj_policy.c
+++ b/src/tspi/obj_policy.c
@@ -302,6 +302,25 @@ done:
 }
 
 TSS_RESULT
+obj_policy_is_secret_set(TSS_HPOLICY hPolicy, TSS_BOOL *secretSet) 
+{
+	struct tsp_object *obj;
+	struct tr_policy_obj *policy;
+	TSS_RESULT result = TSS_SUCCESS;
+
+	if ((obj = obj_list_get_obj(&policy_list, hPolicy)) == NULL)
+		return TSPERR(TSS_E_INVALID_HANDLE);
+
+	policy = (struct tr_policy_obj *)obj->data;
+	
+	*secretSet = policy->SecretSet;
+	obj_list_put(&policy_list);
+	
+	return result;
+}
+	
+
+TSS_RESULT
 obj_policy_set_secret(TSS_HPOLICY hPolicy, TSS_FLAG mode, UINT32 size, BYTE *data)
 {
 	TCPA_DIGEST digest;
diff --git a/src/tspi/obj_rsakey.c b/src/tspi/obj_rsakey.c
index 1a0e0be..6dd664e 100644
--- a/src/tspi/obj_rsakey.c
+++ b/src/tspi/obj_rsakey.c
@@ -9,11 +9,17 @@
  */
 
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <errno.h>
 #include <string.h>
+#ifndef WIN32
 #include <inttypes.h>
+#endif
+
 
 #include "trousers/tss.h"
 #include "trousers/trousers.h"
diff --git a/src/tspi/obj_tpm.c b/src/tspi/obj_tpm.c
index 962fd51..189b296 100644
--- a/src/tspi/obj_tpm.c
+++ b/src/tspi/obj_tpm.c
@@ -9,6 +9,9 @@
  */
 
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <errno.h>
diff --git a/src/tspi/ps/ps_utils.c b/src/tspi/ps/ps_utils.c
index aac40a1..34e4f79 100644
--- a/src/tspi/ps/ps_utils.c
+++ b/src/tspi/ps/ps_utils.c
@@ -9,9 +9,15 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <string.h>
 #include <errno.h>
 
@@ -21,6 +27,9 @@
 #include "spi_utils.h"
 #include "tspps.h"
 #include "tsplog.h"
+#ifdef WIN32
+#include "libc_interface.h"
+#endif
 
 inline TSS_RESULT
 read_data(int fd, void *data, UINT32 size)
diff --git a/src/tspi/ps/tspps.c b/src/tspi/ps/tspps.c
index 9dfc16d..244ad97 100644
--- a/src/tspi/ps/tspps.c
+++ b/src/tspi/ps/tspps.c
@@ -9,19 +9,34 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#ifndef WIN32
 #include <unistd.h>
+#endif
 #include <errno.h>
+#ifndef WIN32
 #include <pwd.h>
+#endif
 #include <sys/types.h>
+#ifndef WIN32
 #include <sys/file.h>
 #include <sys/stat.h>
+#else
+#include <sys/stat.h>
+#include <direct.h>
+#endif
 #include <assert.h>
 #include <fcntl.h>
 #include <limits.h>
+#ifndef WIN32
 #include <netdb.h>
+#endif
 #if defined (HAVE_BYTEORDER_H)
 #include <sys/byteorder.h>
 #elif defined(HAVE_ENDIAN_H)
@@ -42,6 +57,11 @@
 #include "spi_utils.h"
 #include "tspps.h"
 #include "tsplog.h"
+#ifdef WIN32
+#include "flock.h"
+#include "win32dep.h"
+#include "libc_interface.h"
+#endif
 
 static int user_ps_fd = -1;
 static MUTEX_DECLARE_INIT(user_ps_lock);
@@ -69,13 +89,15 @@ get_user_ps_path(char **file)
 {
 	TSS_RESULT result;
 	char *file_name = NULL, *home_dir = NULL;
-	struct passwd *pwp;
 #if (defined (__linux) || defined (linux) || defined(__GLIBC__))
 	struct passwd pw;
 #endif
 	struct stat stat_buf;
 	char buf[PASSWD_BUFSIZE];
+#ifndef WIN32
 	uid_t euid;
+	struct passwd *pwp;
+#endif
 	int rc;
 
 	if ((file_name = getenv("TSS_USER_PS_FILE"))) {
@@ -85,8 +107,9 @@ get_user_ps_path(char **file)
 #if (defined (__FreeBSD__) || defined (__OpenBSD__))
 	MUTEX_LOCK(user_ps_path);
 #endif
-
+#ifndef WIN32
 	euid = geteuid();
+#endif
 
 #if defined (SOLARIS)
 	/*
@@ -98,6 +121,7 @@ get_user_ps_path(char **file)
          */
         rc = snprintf(buf, sizeof (buf), "%s/%d", TSS_USER_PS_DIR, euid);
 #else
+#ifndef WIN32
 	setpwent();
 	while (1) {
 #if (defined (__linux) || defined (linux) || defined(__GLIBC__))
@@ -124,6 +148,9 @@ get_user_ps_path(char **file)
                 }
         }
         endpwent();
+#else
+	home_dir = trousers_getUserDir();
+#endif
 
 	if (!home_dir)
 		return TSPERR(TSS_E_OUTOFMEMORY);
@@ -164,7 +191,7 @@ get_user_ps_path(char **file)
 		      TSS_USER_PS_FILE);
 #endif
 	if (rc == sizeof (buf)) {
-		LogDebugFn("USER PS: Path to file too long! (> %d bytes)", sizeof (buf));
+		LogDebugFn("USER PS: Path to file too long! (> %zd bytes)", sizeof (buf));
 	} else
 		*file = strdup(buf);
 
@@ -206,7 +233,11 @@ get_file(int *fd)
 		return result;
 	}
 
+#ifdef WIN32
+	user_ps_fd = open(file_name, O_CREAT|O_RDWR|O_BINARY, 0600);
+#else
 	user_ps_fd = open(file_name, O_CREAT|O_RDWR, 0600);
+#endif
 	if (user_ps_fd < 0) {
 		LogDebug("USER PS: open of %s failed: %s", file_name, strerror(errno));
 		free(file_name);
diff --git a/src/tspi/rpc/hosttable.c b/src/tspi/rpc/hosttable.c
index f3ec2eb..292138a 100644
--- a/src/tspi/rpc/hosttable.c
+++ b/src/tspi/rpc/hosttable.c
@@ -9,6 +9,9 @@
  */
 
 
+#ifdef WIN32
+#include <windows.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
@@ -20,6 +23,8 @@
 #include "obj.h"
 
 struct host_table *ht = NULL;
+TSS_RESULT host_table_init();
+void host_table_final();
 
 TSS_RESULT
 host_table_init()
@@ -35,6 +40,7 @@ host_table_init()
 	return TSS_SUCCESS;
 }
 
+#ifndef WIN32
 #ifdef SOLARIS
 #pragma init(_init)
 void _init(void)
@@ -45,6 +51,32 @@ void __attribute__ ((constructor)) my_init(void)
 	host_table_init();
 	__tspi_obj_list_init();
 }
+#else
+BOOL APIENTRY DllMain(HINSTANCE hinstDLL,
+		      DWORD fdwReason,
+		      LPVOID lpvReserved)
+{ 
+	switch (fdwReason) { 
+	case DLL_PROCESS_ATTACH: 
+		host_table_init();
+		__tspi_obj_list_init();
+		break; 
+	case DLL_THREAD_ATTACH: 
+		break; 
+	case DLL_THREAD_DETACH: 
+		break; 
+	case DLL_PROCESS_DETACH:
+		host_table_final();
+		break;
+	default: 
+		break; 
+	} 
+
+	return TRUE; 
+	UNREFERENCED_PARAMETER(hinstDLL); 
+	UNREFERENCED_PARAMETER(lpvReserved); 
+}
+#endif
 
 void
 host_table_final()
@@ -69,6 +101,7 @@ host_table_final()
 	ht = NULL;
 }
 
+#ifndef WIN32
 #ifdef SOLARIS
 #pragma fini(_fini)
 void _fini(void)
@@ -78,6 +111,7 @@ void __attribute__ ((destructor)) my_fini(void)
 {
 	host_table_final();
 }
+#endif
 
 TSS_RESULT
 __tspi_add_table_entry(TSS_HCONTEXT tspContext, BYTE *host, int type, struct host_table_entry **ret)
diff --git a/src/tspi/rpc/tcs_api.c b/src/tspi/rpc/tcs_api.c
index 3eeb1fb..f75b911 100644
--- a/src/tspi/rpc/tcs_api.c
+++ b/src/tspi/rpc/tcs_api.c
@@ -9,9 +9,15 @@
  */
 
 
+#ifdef WIN32
+#include <ws2tcpip.h>
+#include <windows.h>
+#endif
 #include <stdlib.h>
+#ifndef WIN32
 #include <syslog.h>
 #include <unistd.h>
+#endif
 
 #include "trousers/tss.h"
 #include "trousers_types.h"
@@ -21,6 +27,9 @@
 #include "tsplog.h"
 #include "rpc_tcstp_tsp.h"
 #include "obj_context.h"
+#ifdef WIN32
+#include "libc_interface.h"
+#endif
 
 
 TSS_RESULT
